<?php
if (!defined('PmWiki'))	exit();
if (!defined('PRESENCE_VERSION') >= 0.6) { echo "first install presence.php";  exit(); }
if (!defined('PRESENCE_ADMINTOOL') >= 0.3) { echo "first install presence-admintool.php"; exit(); }

// Configuration that your probably do not want to change
SDV($HandleActions['newuser'], 'HandleNewUser');
SDV($HandleActions['chprof'], 'HandleChProf');

SDV($NewUserSitePermissions, 'read,edit_page-Main.WikiSandbox,chprof');
SDV($NewUserUnameLen, 5);
SDV($NewUserUpassLen, 5);

SDV($NewUserMessage, "To register as a new user, simply fill out the form below.");
SDV($ChProfMessage, "To chage your profile, simply fill out the form below.");

// Error Messages
SDV($UserToolErrorMessages, array ('username_short' => 'Username too short (min. $NewUserUnameLen chars)!!', 'username_exists' => 'Username already exists!!', 'password_short' => 'Password too short (min. $NewUserUpassLen chars)!!', 'password_mismatch' => 'Password Mismatch!!', 'contact_miss' => 'You have to set Contact field!!', 'contactid_miss' => 'You have to set ContactID field!!', 'contactid_format' => 'Wrong ContactID format!!'));

if (!$NewUserSitePermissions)
	$NewUserSitePermissions = 'read';

function HandleNewUser($pagename) {
	global $NewUserMessage;

	$arg['uname'] = @ $_POST['uname'];
	$arg['upass'] = @ $_POST['upass'];
	$arg['urepass'] = @ $_POST['urepass'];
	$arg['contact'] = @ $_POST['contact'];
	$arg['contactID'] = @ $_POST['contactID'];
	$arg['uname'] = preg_replace('/\s/', '', $arg['uname']);
	$arg['rname'] = $arg['uname'];
	$arg['errors'] = false;

	if ($arg['uname'] || $arg['upass'] || $arg['urepass']) {
		PrintEmbeddedPage($pagename, UserToolAddUser($arg, $pagename));
	} else {
		PrintEmbeddedPage($pagename, UserToolForm($arg, false, $pagename));
	}
}

function HandleChProf($pagename) {
	global $ChProfMessage;
	// These variables are all defined by userauth.php
	global $UserInfoObj, $UserInstanceVars;
	$username = $UserInstanceVars->GetInstanceUsername();

	global $LackProperAbilitiesFmt;

	if (!$UserInfoObj->UserHasAbility($username, 'chprof')) {
		// Tell the user they can not perform this action
		PrintEmbeddedPage($pagename, $LackProperAbilitiesFmt);
		exit;
	}
	$arg['uname'] = $username;
	$arg['upass'] = @ $_POST['upass'];
	$arg['urepass'] = @ $_POST['urepass'];
	$arg['contact'] = @ $_POST['contact'];
	$arg['contactID'] = @ $_POST['contactID'];
	$arg['errors'] = false;

	if ($arg['contact'] || $arg['contactID'] || $arg['upass'] || $arg['urepass'])
		PrintEmbeddedPage($pagename, UserToolChProf($arg, $pagename));
	else {
		$arg['uname'] = $username;
		$arg['upass'] = @ $_POST['upass'];
		$arg['urepass'] = @ $_POST['urepass'];
		$arg['contact'] = $UserInfoObj->GetUserContact($username);
		$arg['contactID'] = $UserInfoObj->GetUserContactID($username);
		$arg['errors'] = false;

		PrintEmbeddedPage($pagename, UserToolForm($arg, true, $pagename));
	}

}

function UserToolForm($arg, $userfield, $pagename) {
	global $ScriptUrl, $HTMLStartFmt, $HTMLEndFmt, $NewUserMessage;

	$uname = $arg['uname'];
	$email = $arg['email'];
	$errs = $arg['errors'];
	$selectTag = GetSelectTag($arg['contact'], "contact");
	$contactID = $arg['contactID'];
	$newuser_form = "
		<p><b>$errs</b></p>
		<h1>".($userfield?"Change Profile":"User Registration").":</h1>
		<form action='{$_SERVER['REQUEST_URI']}' method='POST'>
		  <table>
		    <tr>
		       <td colspan='2'></td>
		    </tr>
		    <tr>
		       <td></td>
		    </tr>";
	//if ($userfield)
	$newuser_form .= "
			    <tr>
			       <td>Username:</td>
			       <td><input ".($userfield? "readonly='readonly'":"")." class='userauthinput' type='text' name='uname' value='$uname' /></td>
			    </tr>";
	$newuser_form .= "
		    <tr>
		       <td>Password:</td>
		       <td><input class='userauthinput' type='password' name='upass' value='$upass' /></td>
		    </tr>
		    <tr>
		       <td>Re Password:</td>
		       <td><input class='userauthinput' type='password' name='urepass' value='$urepass' /></td>
		    </tr>
		    <tr>
		       <td>Contact:</td>
		       <td>
		          $selectTag
		       </td>
		    </tr>
		    
		    <tr>
		       <td>ContactID:</td>
		       <td><input class='userauthinput' type='text' name='contactID' value='$contactID' /></td>
		    </tr>
		    <tr>
		       <td colspan='2' align='center'>
		          <input type='submit' value='Submit' />
		       </td>
		    </tr>
		  </table>
		</form>";
	return FmtPageName($newuser_form, $pagename);
}

function UserToolAddUser($arg, $pagename) {
	//$pagename = $_SERVER['REQUEST_URI'];
	global $UserInfoObj, $AdminToolMainUrl;
	global $PasswordMismatchFmt, $UserAlreadyExistsFmt;
	global $NewUserSitePermissions;
	global $WikiTitle;
	global $NewUserUnameLen, $NewUserUpassLen;

	$arg['errors'] = UserToolCheckForErrors($arg, true);

	if ($arg['errors'])
		return UserToolForm($arg, false, $pagename);
	else {
		$UserInfoObj->AddUser($arg['uname']);

		$abilities_arr = preg_split('/[\s,]+/', $NewUserSitePermissions);

		$UserInfoObj->SetUserPassword($arg['uname'], $arg['upass']);
		$UserInfoObj->SetUserContact($arg['uname'], $arg['contact']);
		$UserInfoObj->SetUserContactID($arg['uname'], $arg['contactID']);
		$UserInfoObj->SetUserAbilities($arg['uname'], $abilities_arr);

		$UserInfoObj->PublishChanges();

		$thanks =<<<THANKS
<h2>New Account Created:</h2>
<p>Thank you, <b>$rname</b> for creating an account on the $WikiTitle website.
Uour permissions are: $NewUserSitePermissions, <br />
The account is ready.</p>
<br />
<p>Now <a href='?action=login'>login!</a></p>
THANKS;
		return $thanks;
	}
}

function UserToolChProf($arg, $pagename) {
	global $UserInfoObj;
	$arg['errors'] = UserToolCheckForErrors($arg, false);

	if ($arg['errors'])
		return UserToolForm($arg, true, $pagename);
	else {
		$UserInfoObj->SetUserPassword($arg['uname'], $_REQUEST['upass']);
		$UserInfoObj->SetUserContact($arg['uname'], $_REQUEST['contact']);
		$UserInfoObj->SetUserContactID($arg['uname'], $_REQUEST['contactID']);
		$UserInfoObj->PublishChanges();
		// Update data so 
		// The user stays logged in with the new data
		

		return "Profile change successful.";
	}
}

function UserToolCheckForErrors($arg, $usercheck) {
	global $UserInfoObj, $NewUserUnameLen, $NewUserUpassLen, $UserToolErrorMessages;
	$uname = $arg['uname'];
	$upass = $arg['upass'];
	$urepass = $arg['urepass'];
	$contact = $arg['contact'];
	$contactID = $arg['contactID'];

	if ($usercheck) {
		if (strlen($uname) < $NewUserUnameLen) {
			$arg['errors'] .= "Error: Username too short (min. $NewUserUnameLen chars)!!<br/>";
		}
		if ($UserInfoObj->DoesUserExist($uname)) {
			$arg['errors'] .= "Error: Username already exists!!<br/>";
		}
	}

	if (strlen($upass) < $NewUserUpassLen) {
		$arg['errors'] .= "Error: Password too short (min. $NewUserUpassLen chars)!!<br/>";
	}

	if ($upass != $urepass) {
		$arg['errors'] .= "Error: Password Mismatch!!<br/>";
	}

	if ($contact && !$contactID) {
		$arg['errors'] .= "Error: You have to set ContactID field!!<br/>";
	}
	elseif (!$contact && $contactID) {
		$arg['errors'] .= "Error: You have to set Contact field!!<br/>";
	}
	elseif ($contact && $contactID) {
		$regexprex = "^([a-zA-Z0-9_\.\-])+\@(([a-zA-Z0-9\-]{2,})+\.)+([a-zA-Z0-9]{2,})$";
		if (!ereg($regexprex, $contactID)) {
			$arg['errors'] .= "Error: Wrong ContactID format!!<br/>";
		}
	}
	return $arg['errors'];
}
?>
