<?php
require ("class.jabber.php");
class CJP_StandardConnector2 extends CJP_StandardConnector {
	function ReadFromSocket($chunksize) {
		set_magic_quotes_runtime(0);
		$buffer = fread($this->active_socket, $chunksize);

		/* l'eliminazione di questa riga  indispensabile per la corretta visualizzazione del sito,
		 * 
		 * Se si abilita magic_quotes_runtime, diverse funzioni che restituiscono dati da ogni
		 * tipo di fonte esterna, compresi i database ed i file di testo, avranno gli apici
		 * preceduti dal backslash.
		 * 
		 * Se  anche attivato magic_quotes_sybase, soltanto l'apice 
		 * singolo sar preceduto dal carattere di escape costituito da un apice singolo anzich
		 * il backslash.
		 * 
		 * Abilitando questa funzione si sfasa il layout del sito.
		 * 
		 * 
		 * 
		 * 		set_magic_quotes_runtime(get_magic_quotes_gpc());
		 * 
		 * 
		 * 
		 */

		return $buffer;
	}
}

class ClassJabberPosts extends Jabber {

	var $OnlineUsers = Array ();

	function ClassJabberPosts($server,$port,$username,$password,$resource=NULL) {
		$this->server = $server;
		$this->port = $port;

		$this->username = $username;
		$this->password = $password;
		$this->resource = $resource;

		$this->enable_logging = FALSE;
		$this->log_array = array ();
		$this->log_filename = '';
		$this->log_filehandler = FALSE;

		$this->packet_queue = array ();
		$this->subscription_queue = array ();

		$this->iq_sleep_timer = 1;
		$this->delay_disconnect = 1;

		$this->returned_keep_alive = TRUE;
		$this->txnid = 0;

		$this->iq_version_name = "Class.Jabber.PHP -- http://cjphp.netflint.net -- by Nathan 'Fritzy' Fritz, fritz@netflint.net";
		$this->iq_version_version = "0.4";
		$this->iq_version_os = $_SERVER['SERVER_SOFTWARE'];

		$this->connection_class = "CJP_StandardConnector2";

		$this->error_codes = array (400 => "Bad Request", 401 => "Unauthorized", 402 => "Payment Required", 403 => "Forbidden", 404 => "Not Found", 405 => "Not Allowed", 406 => "Not Acceptable", 407 => "Registration Required", 408 => "Request Timeout", 409 => "Conflict", 500 => "Internal Server Error", 501 => "Not Implemented", 502 => "Remove Server Error", 503 => "Service Unavailable", 504 => "Remove Server Timeout", 510 => "Disconnected");
	}

	function Handler_presence_available($packet) {
		$from = $this->GetInfoFromPresenceFrom($packet);

		$pres_status = trim($this->GetInfoFromPresenceStatus($packet));
		$pres_show = trim($this->GetInfoFromPresenceShow($packet));
		//echo "\n".$pres_status."-".$pres_show;

		$pres_show = ($pres_show != "") ? $pres_show : "online";

		$this->AddToLog("EVENT: Presence (type: available) - $from is available $pres_status - $pres_show");

		$from = explode("/", $from);

		$this->online_users[$from[0]]['show'] = $pres_show;
		$this->online_users[$from[0]]['status'] = $pres_status;

	}

	function Handler_presence_unavailable($packet) {
		$from = $this->GetInfoFromPresenceFrom($packet);

		$show_status = $this->GetInfoFromPresenceStatus($packet)." / ".$this->GetInfoFromPresenceShow($packet);
		$show_status = ($show_status != " / ") ? " ($addendum)" : '';

		$this->AddToLog("EVENT: Presence (type: unavailable) - $from is unavailable $show_status");

		$from = explode("/", $from);
		unset ($this->online_users[$from[0]]);
	}
/*
	function RosterPrint() {
		//$users = Array();
		$users = $this->roster;
		for ($i = 0; $i < count($this->roster); $i ++) {
			if (isset ($this->online_users[$this->roster[$i]["jid"]])) {
				$users[$i]['show'] = $this->online_users[$this->roster[$i]["jid"]]['show'];
			} else
				$users[$i]['show'] = "offline";
			$users[$i]['status'] = $this->online_users[$this->roster[$i]["jid"]]['status'];

		}

		return $users;
	}
*/
	function _create_logfile() {
		if ($this->log_filename != '' && $this->enable_logging) {
			$this->log_filehandler = fopen($this->log_filename, 'w');
		}
	}

	function PrintLog() { /* Non deve essere stampato nessun log a video */
	}

	function AddToLog($string) {
		if ($this->enable_logging) {
			if ($this->log_filehandler) {
				fwrite($this->log_filehandler, $string."\n"); // scrive il log nel file
				//print "$string \n\n";
			} else {
				$this->log_array[] = htmlspecialchars($string);
			}
		}
	}

}
?>